import fisica.*;

FWorld world;

FBox bucket_left;
FBox bucket_right;
FBox bucket_bottom;

FBox death;
boolean lost = false;

float last_drop;
float drop_time;

void setup()
{
  size( 800, 600 );
  Fisica.init( this );
  
  world = new FWorld();
  
  bucket_bottom = new FBox( 100, 20 );
  bucket_bottom.setPosition( width/2, height - 80 );
  bucket_bottom.setFill( 0, 0, 255 );
  bucket_bottom.setGrabbable( false );
  bucket_bottom.setStaticBody( true );
  world.add( bucket_bottom );
  bucket_left = new FBox( 20, 100 );
  bucket_left.setPosition( width/2-60, height - 100 );
    bucket_left.setGrabbable( false );
  bucket_left.setStaticBody( true );
  world.add( bucket_left );
  bucket_right = new FBox( 20, 100 );
  bucket_right.setPosition( width/2+60, height - 100 );
    bucket_right.setGrabbable( false );
  bucket_right.setStaticBody( true );
  world.add( bucket_right );
  
  death = new FBox( 1000, 10 );
  death.setPosition( width/2, height + 20 );
  death.setStaticBody( true );
  world.add( death );
  
  last_drop = millis();
  drop_time = 1000.0;
  lost = false;
}

void draw()
{
  background( 100 );

  if( millis() - last_drop > 1000 ) {
    FCircle circ = new FCircle( 30 );
    circ.setPosition( random( 0, width ), 30 );
    world.add( circ );
    last_drop = millis();
    drop_time *= 0.95;
  }
  
  if( lost ) {
    text( "YOU LOSE", width/2, height/2 );
  } else {
  world.step();
  world.draw();
  }
}

void mouseMoved()
{
    
  bucket_bottom.setPosition( mouseX, height-80 );
  bucket_left.setPosition( mouseX-60, height - 100 );
  bucket_right.setPosition( mouseX + 60, height - 100 );
  
}

void contactResult( FContactResult con )
{
  if( con.getBody1() == bucket_bottom ) {
    world.remove( con.getBody2() );
  } else if( con.getBody2() == bucket_bottom ) {
    world.remove( con.getBody1() );
  } else if( con.getBody1() == death || con.getBody2() == death ) {
    lost = true;
  }
}
